﻿

#  EXCELファイル名
$Stencil="練りの嵐-ステンシル.xlsx"

#  ステンシルファイルをコピーをする年数
$Years = 10　#年分

echo " "
echo "    ＊＊＊＊　【練りの嵐】一連の練習ファイル群の生成　＊＊＊＊"
echo " "
echo "  　  ステンシルファイル( $Stencil )を、半年単位に $Years 年分コピーして練習ファイルを準備します。"
echo "  　      （銘柄コードを入力し、株価データを装着したステンシルファイルを事前に用意しておいてください。）"
echo " "
echo "     全てのＥＸＣＥＬを一旦閉じてください。ＥＸＣＥＬを自動起動してコピー処理を勧めていきます。"
echo " "
Read-Host "続行するにはEnterキーを押してください . . ."
echo " "

#　EXCELシート名
$MySheetName = "練りの嵐"

#　銘柄コードのカラム番号
$MeigaraColumnNo　=　5

#　銘柄コードの行番号
$MeigaraRowNo　=　3

#　日付のカラム番号
$DateColumnNo　=　1

#　日付の行番号
$DateRowNo　=　4

#　末尾売買のカラム番号
$EndColumnNo　=　5

#　末尾売買の行番号
$EndRowNo　=　137

# 本スクリプトのフルパスを取得します。
$MyScriptFullPath = $MyInvocation.MyCommand.Path

# このフォルダの親フォルダを　作業フォルダとして取得します。
$MyFolderSub = Split-Path -Parent $MyScriptFullPath
$MyFolder = Split-Path -Parent $MyFolderSub

# 作業フォルダの下にステンシルファイルが存在しなければ修了します。
if (-not (Test-Path $MyFolder\$Stencil)) {
        echo " "
        echo " "
        echo "     ＝＝＝＝＝＝＝＝＝＜　ステンシルファイル（$Stencil）が存在しません!!　処理を中断します。"
   　　 echo " "
        Read-Host "続行するにはEnterキーを押してください . . ."
        exit
    }
    

# Excelオブジェクト作成
$excel = New-Object -ComObject Excel.Application
$excel.Visible = $True  #Visible状態にしないと、Excel2016でWindows1をアクティブにできなかったため、Visible設定を使用する。
        
# EXCELからの警告メッセージを表示しないようにします。
$excel.DisplayAlerts = $false


# ステンシルのExcelを開きます。
$book = $excel.Workbooks.Open("$MyFolder\$Stencil")

# Window1をアクティブ化します。
$Dummy = $book.Windows | ForEach-Object {
        if ( $_.WindowNumber -eq 1){
            $_.activate()
        }
}

# 練りの嵐シートから銘柄コードと銘柄名を取り込みます。。
$Sheet = $book.Worksheets.item("$MySheetName")
$Meigara = $Sheet.Cells.Item($MeigaraRowNo,$MeigaraColumnNo).Text
$MeigaraName = $Sheet.Cells.Item($MeigaraRowNo,$MeigaraColumnNo-1).Text
    
# 銘柄コードが4桁数字でなけば処理を中断します。
if ( 　　　　($Meigara.Length -ne 4)`
        -or ($Meigara.Substring(0,1) -lt 0) -or ($Meigara.Substring(0,1) -gt 9)`
        -or ($Meigara.Substring(1,1) -lt 0) -or ($Meigara.Substring(1,1) -gt 9)`
        -or ($Meigara.Substring(2,1) -lt 0) -or ($Meigara.Substring(2,1) -gt 9)`
        -or ($Meigara.Substring(3,1) -lt 0) -or ($Meigara.Substring(3,1) -gt 9)) {

  if ( $Meigara -ne "i101" ) { # 銘柄コードがi101でもなけば処理を中断します。
    echo " "
    echo " "
    echo " "
    echo "      ！！！！！　銘柄コードが4桁数字ではありません。処理を中断します。"
    echo " "
    
　　# EXCELを終了する
    $Book.close()
　　$excel.Quit()
　　# プロセスを解放する
　　$excel = $null
　　[GC]::Collect()

    Read-Host "続行するにはEnterキーを押してください . . ."
    exit
  }
}
if($MeigaraName -eq "#N/A" ) { # 銘柄コードが登録されていなければ処理を中断します。
    echo " "
    echo " "
    echo " "
    echo "      ！！！！！　銘柄コード（$Meigara）が登録されていません。処理を中断します。"
    echo " "
        
　　# EXCELを終了する
    $Book.close()
　　$excel.Quit()
　　# プロセスを解放する
　　$excel = $null
　　[GC]::Collect()

    Read-Host "続行するにはEnterキーを押してください . . ."
    exit
  }
  
#---------------------        
# 末尾売買欄にドットを設定します。
$sheet.Cells.Item($EndRowNo,$EndColumnNo).Value() = "."

# 処理日の年月を取得します（年は数値、月は文字列）
$TodayY = [int](Get-Date).ToString("yyyy")
$TodayM = (Get-Date).ToString("MM")

echo " "
echo "     ＝＝＝＝＝＝＝＝＝＝＝＜　ステンシルの情報　  銘柄：$Meigara $MeigaraName  ＞＝＝＝＝"
echo " "

for ( $i = $TodayY - $Years ; $i -le $TodayY; $i++ )
{
 
  $aryMM=@("01","07")
  foreach($MM in $aryMM){

    if ( $i -eq $TodayY -and $MM -eq "07" -and ${TodayM} -le "06")
    {
        echo " "
        #echo "     ＝＝＝＝＝＝＝＝＜　　スキップ　${Meigara}${MeigaraName}_${i}${MM}01.xlsx "

    }else{

        # 開始日付を設定
        $sheet.Cells.Item($DateRowNo,$DateColumnNo).Value() = "${i}/${MM}/01"
        
        # 別名保存
        $book.SaveAs("$MyFolder\${Meigara}${MeigaraName}_${i}${MM}01.xlsx")

        echo " "
        echo "     ＝＝＝＝＝＝＝＝＜　　${Meigara}${MeigaraName}_${i}${MM}01.xlsx を作成しました。"

     }
  }   
}


# EXCELを終了する
$Book.close()
$excel.Quit()
# プロセスを解放する
$excel = $null
[GC]::Collect()


echo " "
Read-Host "続行するにはEnterキーを押してください . . ."